; install.scm
; $Id: update.scm,v 1.10 2006/03/23 14:10:27 inger Exp $
(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-packages")

width 400
height 200
title (_ "Updating Indices...")

margin 10
spacing 10

(define *packages-progress-error* (make-cell '()))

(define (packages-update-progress args)
  (let ((command (car args))
        (arg (cadr args))
        (rest (if (pair? (cddr args)) (caddr args) "")))
    (cond
     ;; begin
     ((and (string=? command "progress")
           (string=? arg "begin"))
      (packages-update-label-id text (_ "Preparing...")))
     ;; start update
     ((and (string=? command "progress")
           (string=? arg "update"))
      (packages-update-label-id text (_ "Updating..."))
      (packages-update-bar-id maximum (string->number rest))
      (packages-update-bar-id value 0)
      (packages-update-text-id text ""))
     ;; update progress bar
     ((string=? command "step")
      (let ((val (+ 1 (packages-update-bar-id value))))
        (packages-update-text-id append-text arg)
        (packages-update-bar-id value val)))
     ;; accumulate errors
     ((string=? command "error")
      (cell-set! *packages-progress-error*
                 (acons arg rest
			(cell-ref *packages-progress-error*))))
     ;; normal termination
     ((and (string=? command "progress")
           (string=? arg "end"))
      (document-exit (or (null? (cell-ref *packages-progress-error*))
                         (cell-ref *packages-progress-error*))))
     ;; abort
     ((and (string=? command "progress")
           (string=? arg "abort"))
      (document-exit #f))
     ;; uncatched
     (else
      (packages-update-text-id
       append-text (string-append "XXX" command ":" arg "\n"))))))

(define (document-exit-1 value)
  (document:end value))

(define (document-exit value)
  (remove-mailbox packages-update-progress)
  (document-exit-1 value)
  (simple-notify document:root 'action "retry"))

(define (packages-update)
  (woo-write "/packages/control" 'control "quit")
  (woo-write "/packages/control" 'control "update")
  (add-mailbox packages-update-progress))

(document:id packages-update-label-id
             (label (_ "Updating Indices...")))

(document:id packages-update-text-id
             (textbox "" alterability #f))

(document:id packages-update-bar-id
             (progressbar layout-policy 100 -1 maximum 1 value 0))

(document:root (when loaded  (packages-update)))
