; groups; $Id: view-groups.scm,v 1.16 2006/03/28 11:13:54 inger Exp $

(document:envelop let () )

(define *packages-groups-major-current* (make-cell #f))
(define *packages-groups-minor-current* (make-cell #f))

(define (packages-groups-major)
  (woo-list-names "/packages/groups"))

(define (packages-groups-label->group label)
  (assoc-ref (cell-ref *packages-groups-major-labels*) label))

(define (packages-groups-minor label)
  (cell-set! *packages-groups-major-current* label)
  (cell-set! *packages-groups-minor-current*
             (packages-groups-minor-1
              (cell-ref *packages-groups-major-current*)))
  (cell-ref *packages-groups-minor-current*))

(define (packages-groups-minor-1 group)
  (map
   (lambda (e)
     (let ((e-list (string-split e #\:)))
       (cons (car e-list) (cadr e-list))))
   (let ((address (string-append "/packages/groups/" group)))
     (sort (woo-list-names address) string<))))

(define (packages-groups-elt elt)
  (woo-first-command
   (woo-read
    (string-append "/packages/groups/"
                   (cell-ref *packages-groups-major-current*)  "/" elt))))

(define (packages-groups-elt-version elt)
  (woo-get-option (packages-groups-elt elt) 'version))

(define (packages-groups-elt-summary elt)
  (woo-get-option (packages-groups-elt elt) 'summary))

(define (packages-groups-elt-description elt)
  (woo-get-option (packages-groups-elt elt) 'description))

(define (packages-groups-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *packages-groups-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-upgraded")
                             (string=? state "be-installed")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;;------------------------------------------------------------------------------
(cons
 'groups
 (list (cons 'label (_ "Groups"))
       (cons 'type 'static)
       (cons 'major packages-groups-major)
       (cons 'minor packages-groups-minor)
       (cons 'elt-version packages-groups-elt-version)
       (cons 'elt-summary packages-groups-elt-summary)
       (cons 'elt-description packages-groups-elt-description)
       (cons 'elt-state packages-groups-elt-state)))
