; $Id: view-pending.scm,v 1.10 2006/03/28 11:13:54 inger Exp $

(document:envelop let () )

(define *packages-pending-major-current* (make-cell #f))
(define *packages-pending-minor-current* (make-cell #f))

(define *packages-pending-major-labels*
  (list (_ "keep") (_ "install") (_ "remove") (_ "upgrade") (_ "essential")))

(define *packages-pending-major-states*
  '(("keep" . "upgradable")
    ("install" . "be-installed")
    ("remove" . "be-removed")
    ("essential" . "be-removed")
    ("upgrade" . "be-upgraded")))

(define (packages-pending-major->state major)
  (assoc-ref *packages-pending-major-states* major))

(define (packages-pending-major)
  (woo-list-names "/packages/pending"))

(define (packages-pending-minor label)
  (cell-set! *packages-pending-major-current* label)
  (cell-set! *packages-pending-minor-current*
             (packages-pending-minor-1
              (cell-ref *packages-pending-major-current*)))
  (cell-ref *packages-pending-minor-current*))

(define (packages-pending-minor-1 major)
  (or
   (and major
        (map
         (lambda (e)
           (cons e (packages-pending-major->state major)))
         (let ((address (string-append "/packages/pending/" major)))
           (sort (woo-list-names address) string<))))
   '()))

(define (packages-pending-elt elt)
  (woo-first-command
   (woo-read
    (string-append "/packages/pending/"
                   (cell-ref *packages-pending-major-current*)  "/" elt))))

(define (packages-pending-elt-version elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-pending-elt elt) 'version)))

(define (packages-pending-elt-summary elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-pending-elt elt) 'summary)))

(define (packages-pending-elt-description elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-pending-elt elt) 'description)))

(define (packages-pending-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *packages-pending-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-installed")
                             (string=? state "be-upgraded")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;;------------------------------------------------------------------------------
(cons
 'pending
 (list (cons 'label (_ "Pending"))
       (cons 'type 'dynamic)
       (cons 'major packages-pending-major)
       (cons 'minor packages-pending-minor)
       (cons 'elt-version packages-pending-elt-version)
       (cons 'elt-summary packages-pending-elt-summary)
       (cons 'elt-description packages-pending-elt-description)
       (cons 'elt-state packages-pending-elt-state)))
