; search
; $Id: view-search.scm,v 1.3 2006/03/27 12:09:33 inger Exp $

(document:envelop let () )

(define *packages-search-major* (make-cell '()))
(define *packages-search-major-current* (make-cell #f))
(define *packages-search-minor-current* (make-cell #f))

(define (packages-search-add major)
  (or (string=? major "")
      (member major (cell-ref *packages-search-major*))
      (cell-set! *packages-search-major*
                 (cons major (cell-ref *packages-search-major*)))))

(define (packages-search-major)
  (cell-ref *packages-search-major*))

(define (packages-search-minor major)
  (cell-set! *packages-search-major-current* major)
  (cell-set! *packages-search-minor-current*
             (packages-search-minor-1 major))
  (cell-ref *packages-search-minor-current*))

(define (packages-search-minor-1 major)
  (map
   (lambda (e)
     (let ((e-list (string-split e #\:)))
       (cons (car e-list) (cadr e-list))))
   (let ((address (string-append "/packages/search/" major)))
     (sort (woo-list-names address) string<))))

(define (packages-search-elt elt)
  (woo-first-command
   (woo-read
    (string-append "/packages/search/"
                   (cell-ref *packages-search-major-current*)  "/" elt))))

(define (packages-search-elt-version elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-search-elt elt) 'version)))

(define (packages-search-elt-summary elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-search-elt elt) 'summary)))

(define (packages-search-elt-description elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (packages-search-elt elt) 'description)))

(define (packages-search-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *packages-search-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-installed")
                             (string=? state "be-upgraded")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;;------------------------------------------------------------------------------
(cons
 'search
 (list (cons 'label (_ "Search"))
       (cons 'type 'dynamic)
       (cons 'add packages-search-add)
       (cons 'major packages-search-major)
       (cons 'minor packages-search-minor)
       (cons 'elt-version packages-search-elt-version)
       (cons 'elt-summary packages-search-elt-summary)
       (cons 'elt-description packages-search-elt-description)
       (cons 'elt-state packages-search-elt-state)))

